<?php

namespace App\Console;

use App\Console\Commands\GenerateUpcomingRenewalSubscriptionCompanyOrder;
use App\Console\Commands\GenerateUpcomingRenewalUserSubscriptionBoxOrder;
use App\Console\Commands\ResetSubscriptionWodCounters;
use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        //
    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule) {
        //Reset subscriptions wod counters
        $schedule->command(ResetSubscriptionWodCounters::class)
            ->weekly()
            ->mondays()
            ->between("0:00", "6:00");

        //Generate box orders automatically
        $schedule->command(GenerateUpcomingRenewalUserSubscriptionBoxOrder::class)
            ->daily();

        //Generate company orders automatically
        $schedule->command(GenerateUpcomingRenewalSubscriptionCompanyOrder::class)
            ->daily();
    }

    /**
     * Register the commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        $this->load(__DIR__.'/Commands');

        require base_path('routes/console.php');
    }
}
